add_definitions(
  -DFILETRANSFER
  -DGROUPCHAT
  -DWHITEBOARDING
  -DNEWCONTACTLIST
  -DHAVE_PGPUTIL
  -DPSI_PLUGINS
  -DWEBKIT
  -DUSE_PEP
  -DQT_STATICPLUGIN
)

if(UNIX AND NOT APPLE)
  add_definitions(
    -DUSE_DBUS
    -DHAVE_X11
  )
endif()

if(APPLE)
  add_definitions(
    -DHAVE_GROWL
  #  -DHAVE_SPARKLE
  )
endif()

include_directories(.)

list(APPEND FORMS
  profileopen.ui
  profilemanage.ui
  profilenew.ui
  homedirmigration.ui
  proxy.ui
  accountmanage.ui
  accountadd.ui
  accountreg.ui
  accountremove.ui
  accountmodify.ui
  changepw.ui
  addurl.ui
  adduser.ui
  info.ui
  search.ui
  about.ui
  history.ui
  passphrase.ui
  mucconfig.ui
  mucreasonseditor.ui
  xmlconsole.ui
  disco.ui
  tip.ui
  mood.ui
  activity.ui
  voicecall.ui
  chatdlg.ui
  bookmarkmanage.ui
  ahcommanddlg.ui
  ahcformdlg.ui
  geolocation.ui
  rosteravatarframe.ui
  sendbuttontemplateseditor.ui
  filetrans.ui
  groupchatdlg.ui
  mucjoin.ui
  groupchattopicdlg.ui
  pgpkey.ui
  multiplesend.ui
)

list(APPEND HEADERS
  abstracttreemodel.h
  aboutdlg.h
  accountadddlg.h
  accountlabel.h
  accountloginpassword.h
  accountmanagedlg.h
  accountmodifydlg.h
  accountregdlg.h
  accountscombobox.h
  accountstatusmenu.h
  actionlist.h
  activecontactsmenu.h
  activeprofiles.h
  activitydlg.h
  adduserdlg.h
  ahcformdlg.h
  ahcommanddlg.h
  alerticon.h
  alertmanager.h
  avatars.h
  bobfilecache.h
  bookmarkmanagedlg.h
  bookmarkmanager.h
  bosskey.h
  bytearrayreply.h
  changepwdlg.h
  chatdlg.h
  chateditproxy.h
  chatsplitter.h
  chatview_webkit.h
  chatview_webkit_p.h
  chatviewtheme_p.h
  chatviewthemeprovider.h
  coloropt.h
  contactlistaccountmenu.h
  contactlistdragmodel.h
  contactlistdragview.h
  contactlistgroupmenu.h
  contactlistgroupmenu_p.h
  contactlistitemmenu.h
  contactlistmodel.h
  contactlistmodel_p.h
  contactlistmodelselection.h
  contactlistproxymodel.h
  contactlistview.h
  contactlistviewdelegate.h
  contactlistviewdelegate_p.h
  contactupdatesmanager.h
  discodlg.h
  eventdb.h
  edbsqlite.h
  eventdlg.h
  filecache.h
  filetransdlg.h
  fileutil.h
  gcuserview.h
  geolocationdlg.h
  globalstatusmenu.h
  groupchatdlg.h
  groupchattopicdlg.h
  groupmenu.h
  historydlg.h
  historyimp.h
  homedirmigration.h
  hoverabletreeview.h
  htmltextcontroller.h
  httpauthmanager.h
  infodlg.h
  invitetogroupchatmenu.h
  main.h
  mainwin.h
  mainwin_p.h
  mcmdmanager.h
  miniclient.h
  mooddlg.h
  msgmle.h
  mucaffiliationsmodel.h
  mucaffiliationsproxymodel.h
  mucaffiliationsview.h
  mucconfigdlg.h
  mucjoindlg.h
  mucmanager.h
  mucreasonseditor.h
  multiplesend.h
  networkaccessmanager.h
  passdialog.h
  passphrasedlg.h
  pepmanager.h
  pgpkeydlg.h
  pgptransaction.h
  pgputil.h
  pluginhost.h
  pluginmanager.h
  profiledlg.h
  proxy.h
  psiaccount.h
  psiapplication.h
  psichatdlg.h
  psicli.h
  psicon.h
  psicontact.h
  psicontactlist.h
  psicontactlistview.h
  psicontactmenu.h
  psicontactmenu_p.h
  psievent.h
  psifilteredcontactlistview.h
  psiiconset.h
  psioptions.h
  psipopup.h
  psirosterwidget.h
  psithememanager.h
  psithememodel.h
  psithemeprovider.h
  psithemeviewdelegate.h
  psitoolbar.h
  psitrayicon.h
  registrationdlg.h
  resourcemenu.h
  rosteravatarframe.h
  rosteritemexchangetask.h
  searchdlg.h
  sendbuttonmenu.h
  serverinfomanager.h
  serverlistquerier.h
  showtextdlg.h
  statuscombobox.h
  statusdlg.h
  statusmenu.h
  tabcompletion.h
  tasklist.h
  timeserver.h
  tipdlg.h
  translationmanager.h
  vcardfactory.h
  vcardphotodlg.h
  voicecalldlg.h
  voicecaller.h
  webview.h
  xdata_widget.h
  xmlconsole.h
  xmlhighlighter.h
)

# Source files
list(APPEND SOURCES
  accountmanagedlg.cpp
  actionlist.cpp
  activecontactsmenu.cpp
  ahcservermanager.cpp
  alerticon.cpp
  avatars.cpp
  contactlistaccountmenu.cpp
  discodlg.cpp
  eventdlg.cpp
  filetransdlg.cpp
  gcuserview.cpp
  groupchatdlg.cpp
  htmltextcontroller.cpp
  httpauthmanager.cpp
  mainwin_p.cpp
  msgmle.cpp
  proxy.cpp
  psiaccount.cpp
  psiactionlist.cpp
  psichatdlg.cpp
  psicon.cpp
  psicontactlistview.cpp
  psievent.cpp
  psipopup.cpp
  psirosterwidget.cpp
  registrationdlg.cpp
  searchdlg.cpp
  xdata_widget.cpp
)

list(APPEND PLAIN_HEADERS
  multiplesend_p.h
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

# config.h is a generated file
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/config.h
  PROPERTIES GENERATED TRUE
  HEADER_FILE_ONLY TRUE
)

if(LINUX)
  list(APPEND SOURCES
    dbus.cpp
  )

  list(APPEND PLAIN_SOURCES
    activeprofiles_dbus.cpp
    x11windowsystem.cpp
    psidbusnotifier.cpp
  )

  list(APPEND HEADERS
    psidbusnotifier.h
  )

  list(APPEND PLAIN_HEADERS
    x11windowsystem.h
    dbus.h
  )
elseif(APPLE)
  list(APPEND PLAIN_SOURCES
    psigrowlnotifier.cpp
    activeprofiles_stub.cpp
    AutoUpdater/sparkleautoupdater.mm
    CocoaUtilities/CocoaInitializer.mm
    CocoaUtilities/CocoaTrayClick.mm
    CocoaUtilities/cocoacommon.mm
  )

  list(APPEND HEADERS
    CocoaUtilities/CocoaTrayClick.h
    psigrowlnotifier.h
  )

  list(APPEND PLAIN_HEADERS
    AutoUpdater/AutoUpdater.h
    AutoUpdater/sparkleautoupdater.h
    CocoaUtilities/CocoaInitializer.h
    CocoaUtilities/cocoacommon.h
  )
elseif(WIN32)
  list(APPEND PLAIN_SOURCES
    activeprofiles_win.cpp
  )  
endif()

list(APPEND PLAIN_HEADERS
  abstracttreeitem.h
  activity.h
  activitycatalog.h
  ahcexecutetask.h
  ahcommand.h
  ahcommandserver.h
  ahcservermanager.h
  alertable.h
  applicationinfo.h
  chatview.h
  chatviewcommon.h
  chatviewtheme.h
  common.h
  conferencebookmark.h
  contactlistitem.h
  debug.h
  desktoputil.h
  dummystream.h
  emoji.h
  edbsqlite_p.h
  entitytimetask.h
  geolocation.h
  jidutil.h
  jsutil.h
  lastactivitytask.h
  mcmdcompletion.h
  messageview.h
  minicmd.h
  mood.h
  moodcatalog.h
  physicallocation.h
  pixmaputil.h
  popupmanager.h
  profiles.h
  psiactionlist.h
  psiactions.h
  psihttpauthrequest.h
  psipopupinterface.h
  psiwkavatarhandler.h
  pubsubsubscription.h
  rc.h
  rtparse.h
  shortcutmanager.h
  statuspreset.h
  systeminfo.h
  textutil.h
  theme.h
  urlbookmark.h
  userlist.h
  varlist.h
)

list(APPEND PLAIN_SOURCES
  abstracttreeitem.cpp
  abstracttreemodel.cpp
  aboutdlg.cpp
  accountadddlg.cpp
  accountlabel.cpp
  accountloginpassword.cpp
  accountmodifydlg.cpp
  accountregdlg.cpp
  accountscombobox.cpp
  accountstatusmenu.cpp
  activeprofiles.cpp
  activity.cpp
  activitycatalog.cpp
  activitydlg.cpp
  adduserdlg.cpp
  ahcexecutetask.cpp
  ahcformdlg.cpp
  ahcommand.cpp
  ahcommanddlg.cpp
  ahcommandserver.cpp
  alertable.cpp
  alertmanager.cpp
  applicationinfo.cpp
  bobfilecache.cpp
  bookmarkmanagedlg.cpp
  bookmarkmanager.cpp
  bosskey.cpp
  bytearrayreply.cpp
  changepwdlg.cpp
  chatdlg.cpp
  chateditproxy.cpp
  chatsplitter.cpp
  chatview_webkit.cpp
  chatviewcommon.cpp
  chatviewtheme.cpp
  chatviewthemeprovider.cpp
  coloropt.cpp
  common.cpp
  conferencebookmark.cpp
  contactlistdragmodel.cpp
  contactlistdragview.cpp
  contactlistgroupmenu.cpp
  contactlistitem.cpp
  contactlistitemmenu.cpp
  contactlistmodel.cpp
  contactlistmodelselection.cpp
  contactlistproxymodel.cpp
  contactlistview.cpp
  contactlistviewdelegate.cpp
  contactupdatesmanager.cpp
  debug.cpp
  desktoputil.cpp
  dummystream.cpp
  entitytimetask.cpp
  eventdb.cpp
  edbsqlite.cpp
  filecache.cpp
  fileutil.cpp
  fileutil.cpp
  geolocation.cpp
  geolocationdlg.cpp
  globalstatusmenu.cpp
  groupchattopicdlg.cpp
  groupmenu.cpp
  historydlg.cpp
  historyimp.cpp
  homedirmigration.cpp
  hoverabletreeview.cpp
  infodlg.cpp
  infodlg.cpp
  invitetogroupchatmenu.cpp
  jidutil.cpp
  jsutil.cpp
  lastactivitytask.cpp
  main.cpp
  mainwin.cpp
  mcmdcompletion.cpp
  mcmdmanager.cpp
  mcmdsimplesite.cpp
  messageview.cpp
  miniclient.cpp
  mood.cpp
  moodcatalog.cpp
  mooddlg.cpp
  mucaffiliationsmodel.cpp
  mucaffiliationsproxymodel.cpp
  mucaffiliationsview.cpp
  mucconfigdlg.cpp
  mucjoindlg.cpp
  mucmanager.cpp
  mucreasonseditor.cpp
  multiplesend.cpp
  networkaccessmanager.cpp
  passdialog.cpp
  passphrasedlg.cpp
  pepmanager.cpp
  pgpkeydlg.cpp
  pgptransaction.cpp
  pgputil.cpp
  physicallocation.cpp
  pixmaputil.cpp
  pluginhost.cpp
  pluginmanager.cpp
  popupmanager.cpp
  profiledlg.cpp
  psi_profiles.cpp
  psiapplication.cpp
  psicontactlist.cpp
  psicontactmenu.cpp
  psifilteredcontactlistview.cpp
  psiiconset.cpp
  psicontact.cpp
  psioptions.cpp
  psipopupinterface.cpp
  psithememanager.cpp
  psithememodel.cpp
  psithemeprovider.cpp
  psithemeviewdelegate.cpp
  psitoolbar.cpp
  psitrayicon.cpp
  psiwkavatarhandler.cpp
  pubsubsubscription.cpp
  rc.cpp
  resourcemenu.cpp
  rosteravatarframe.cpp
  rosteritemexchangetask.cpp
  rtparse.cpp
  sendbuttonmenu.cpp
  serverinfomanager.cpp
  serverlistquerier.cpp
  shortcutmanager.cpp
  showtextdlg.cpp
  statuscombobox.cpp
  statusdlg.cpp
  statusmenu.cpp
  statuspreset.cpp
  systeminfo.cpp
  tabcompletion.cpp
  textutil.cpp
  theme.cpp
  timeserver.cpp
  tipdlg.cpp
  translationmanager.cpp
  urlbookmark.cpp
  userlist.cpp
  varlist.cpp
  vcardfactory.cpp
  vcardphotodlg.cpp
  voicecalldlg.cpp
  webview.cpp
  xmlconsole.cpp
  xmlhighlighter.cpp
)
